.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include mult_desks.inc

	OpenDeskList proto :DWORD
	SaveDeskList proto :DWORD

.data
	openKey     db "Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders",0
	value       db "Desktop",0
	terminator1 db "Progman",0
	terminator2 db "Explorer.exe",0
	dirs        db "Directories",0
	desk0       db "desktop0",0
	desk1       db "desktop1",0
	desk2       db "desktop2",0
	desk3       db "desktop3",0
	iniFile     db "mult_desks.ini",0
.data?
	dir0 db 256 dup (?)
	dir1 db 256 dup (?)
	dir2 db 256 dup (?)
	dir3 db 256 dup (?)
.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL pid:DWORD
	LOCAL handle:DWORD
	LOCAL editID:DWORD
	LOCAL opKey:DWORD
	LOCAL bufSize:DWORD
	LOCAL buf[256]:BYTE
	
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke OpenDeskList,  hWin
		
	.elseif eax==WM_COMMAND
		mov    eax, wParam 
		.if eax == 1001 || eax == 1002 || eax == 1003 || eax == 1004
			sub    eax, 1001
			add    eax, 1005
			mov    editID, eax
			;-----------------
			invoke GetDlgItemText, hWin, editID, ADDR buf, 256
			inc    eax
			mov    bufSize, eax
			invoke RegOpenKeyEx, HKEY_CURRENT_USER, ADDR openKey, 0, KEY_SET_VALUE, ADDR opKey
			invoke RegSetValueEx, opKey, ADDR value, 0, REG_EXPAND_SZ, ADDR buf, bufSize
			invoke RegCloseKey, opKey
			;-----------------
			mov pid, 0
			invoke FindWindow, ADDR terminator1, 0
			mov    ecx, eax
			invoke GetWindowThreadProcessId, ecx, ADDR pid
			.if pid
				invoke OpenProcess, PROCESS_TERMINATE, FALSE, pid
				mov    handle, eax
				.if eax
					invoke TerminateProcess, handle, 0
					invoke CloseHandle, handle
				.endif
			.endif
			invoke WinExec, ADDR terminator2, SW_SHOW
			;------------------
		.endif
	.elseif eax==WM_CLOSE
		invoke SaveDeskList, hWin
		invoke EndDialog, hWin, 0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

OpenDeskList proc hWin:DWORD
	LOCAL buf[256]:BYTE
	
	invoke GetAppPath, ADDR buf
	invoke lstrcat, ADDR buf, ADDR iniFile
	invoke GetPrivateProfileString, ADDR dirs, ADDR desk0, 0, ADDR dir0, 256, ADDR buf
	invoke GetPrivateProfileString, ADDR dirs, ADDR desk1, 0, ADDR dir1, 256, ADDR buf
	invoke GetPrivateProfileString, ADDR dirs, ADDR desk2, 0, ADDR dir2, 256, ADDR buf
	invoke GetPrivateProfileString, ADDR dirs, ADDR desk3, 0, ADDR dir3, 256, ADDR buf
	invoke SetDlgItemText, hWin, 1005, ADDR dir0
	invoke SetDlgItemText, hWin, 1006, ADDR dir1
	invoke SetDlgItemText, hWin, 1007, ADDR dir2
	invoke SetDlgItemText, hWin, 1008, ADDR dir3

	ret
OpenDeskList endp

SaveDeskList proc hWin:DWORD
	LOCAL buf[256]:BYTE
	
	invoke GetAppPath, ADDR buf
	invoke lstrcat, ADDR buf, ADDR iniFile
	invoke GetDlgItemText, hWin, 1005, ADDR dir0, 256
	invoke GetDlgItemText, hWin, 1006, ADDR dir1, 256
	invoke GetDlgItemText, hWin, 1007, ADDR dir2, 256
	invoke GetDlgItemText, hWin, 1008, ADDR dir3, 256
	invoke WritePrivateProfileString, ADDR dirs, ADDR desk0, ADDR dir0, ADDR buf
	invoke WritePrivateProfileString, ADDR dirs, ADDR desk1, ADDR dir1, ADDR buf
	invoke WritePrivateProfileString, ADDR dirs, ADDR desk2, ADDR dir2, ADDR buf
	invoke WritePrivateProfileString, ADDR dirs, ADDR desk3, ADDR dir3, ADDR buf	
	
	ret

SaveDeskList endp

end start
